--
-- file:   strlist.e
-- author: Normand M. Blais
-- date:   January 4 1999
--
------------------------------<string_type>--------------------------------
-- type string
-- Definition: string =  sequence of (printable) characters.
-- Ex.: sequence s
--               s = "Hello World"
--
global type string_type(object x)
   if sequence(x) then
      if length(x) = 0 then
         return 1 -- empty string
      else 
         for i=1 to length(x) do
            if not atom(x[i]) then -- not a character
               return 0
            elsif not (x[i] >= 32 and x[i] <= 126) then -- not printable
               return 0
            end if
         end for   
         return 1 -- all printable characters
      end if
   end if
   return 0
end type        


------------------------------<list_type>--------------------------------
-- type list
-- Definition: list = a sequence of strings
-- Ex.: list_type s
--               s = {"Hello", "World"}
--
global type list_type(object x)
   if sequence(x) then
      if length(x) = 0 then
         return 1 -- empty list
      else 
         for i=1 to length(x) do
            if not string_type(x[i]) then -- not a string
               return 0 -- not a list
            end if
         end for   
         return 1 -- a list
      end if
   end if
   return 0 -- not a list
end type        

------------------------------<split>--------------------------------

global function split(string_type str, integer separ)
-- This function takes as arguments a string and 
-- an integer value representing a key character 
-- in the string (the separator).
-- The function returns a sequence of strings.
-- The characters are grouped together until the 
-- separator is found. Then, a new sequence of 
-- characters is initiated. 
    list_type s,t
    integer a
    if length(str) = 0 then
       return str 
    end if      
    s = {}
    t = {}     
    a = 1
    for i=1 to length(str) do
        if str[i] = separ then
           s = append(s,str[a..i-1])
           a = i+1
        end if
    end for
    s = append(s,str[a..length(str)])   
    return s
end function

------------------------------<join>--------------------------------
global function join(list_type l, integer separ)
-- This function takes as arguments a list of strings and 
-- an integer value representing a character separator.
-- The function returns the concatenated string.
    string_type s
    if length(l) = 0 then
       return l 
    end if     
    s = {}
    for i=1 to length(l) do
        s = s & l[i] & separ
    end for                 
    return s
end function



global function my_split(sequence str, integer separ)--this just here to have a diff name
-- This function takes as arguments a string and 
-- an integer value representing a key character 
-- in the string (the separator).
-- The function returns a sequence of strings.
-- The characters are grouped together until the 
-- separator is found. Then, a new sequence of 
-- characters is initiated. 
    sequence s,t
    integer a
    if length(str) = 0 then
       return str 
    end if      
    s = {}
    t = {}     
    a = 1
    for i=1 to length(str) do
        if str[i] = separ then
           s = append(s,str[a..i-1])
           a = i+1
        end if
    end for
    s = append(s,str[a..length(str)])   
    return s
end function
