--modified sort.e 
include wildcard.e
--include ReTrack.ew as Track
--include Radio.ew as Radio

global function myTrueSort(sequence d)
   sequence newDir,allFiles,sortedFile
     newDir={}
     allFiles={}
    for x=1 to length(d) do
      if compare(d[x][1],".")=0 or compare(d[x][1],"..")=0 then
           newDir=append(newDir,d[x])
      else
          allFiles=append(allFiles,d[x][1])--extract just the files names
      end if
    end for
       allFiles=nat_sort_str(allFiles)
          for x =1 to length(allFiles) do
               sortedFile=repeat({},9)
               sortedFile[1]=allFiles[x]--name     
           --    notelog(sprintf("%d allFiles=%s",{x,allFiles[x]}))
               newDir=append(newDir,sortedFile)
          end for
   return newDir
end function

global function myRandSort(sequence d)
  sequence newDir,allFiles,newFiles,done
  integer num,a
  newDir={}
  allFiles={}
  newFiles={}
  done={}
   for x=1 to length(d) do
      if compare(d[x][1],".")=0 or compare(d[x][1],"..")=0 then
           newDir=append(newDir,d[x])
      else
          allFiles=append(allFiles,d[x])--extract just the files
      end if
   end for
    while length(done)<length(allFiles) do
      num = rand(length(allFiles)) 
      a=find(num,done)
         if a=0 then
            done=append(done,num)
            newDir=append(newDir,d[num])         
         end if
    end while
 return newDir
end function

--added by don cole
global function upper_case_sort3(sequence x)  
     -- if Radio:GetCheck(Radio1) then --note radio1 is the lower one 
    --  return myRandSort(x)--random       
   --  else
        return myTrueSort(x)--sorted
    --  end if
end function

--Sorts sequence according to upper case (but doesnt modify sequence)
--for use in sorting directory and file names ignoring case (like Explorer filename lists).
--See notes below also.
--For use with any program.

global function upper_case_sort2(sequence x)--al's version
-- Sort a sequence by ascending upper case order. The elements can be atoms or 
-- sequences. The standard compare() routine is used to compare elements.
    integer gap, j, first, last
    object tempi, tempj
--abort(0)
    last = length(x)
    gap = floor(last / 3) + 1
    while 1 do
    first = gap + 1
    for i = first to last do
        tempi = x[i]
        j = i - gap
        while 1 do
        tempj = x[j]
        if compare(upper(tempi), upper(tempj)) >= 0 then
            j = j + gap
            exit
        end if
        x[j+gap] = tempj
        if j <= gap then
            exit
        end if
        j = j - gap
        end while
        x[j] = tempi
    end for
    if gap = 1 then
        return x
    else
        gap = floor(gap / 3) + 1
    end if
    end while
end function

--other notes:

--you cant really use this to sort complete paths if you want the sort to act like
--windows explorer if the paths contain any '\\' characters (usually the case) because
--the '\\' char is midway between upper case chars and lower case chars.
--One way around this is to replace all the '\\' chars with the control char #1B and then
--after using upper case sort replace all the #1B chars with '\\' chars again.

--There are obvious ways to improve the algorithm execution speed.

