

 integer printErr
   constant App  = "Generic Demo"

global function printPage(integer id ,sequence doc)
    -- prints document on page
    -- returns amount of document not printed yet
    integer pageY, fontY, y, z
    sequence result
    if length( doc ) = 0 then    -- is the document empty?
        return doc        -- do nothing
    end if
        if id=Printer then
            if not startPage() then        -- start a new page
              printErr = True             -- set error and return empty sequence
              return {}
             end if
         end if
    result = getFontSize( id )    -- get the attributes of font
    fontY = result[2]
    result = getCtlSize( id )    -- get the attributes of the page
    pageY = result[2]
    -- start at top of page
    y = 0
    z = 1
    while z <= length(doc) do
        -- out of space?
        if y + fontY > pageY then
            exit
        end if
        -- print on page
        setPenPosition( id, 0, y )
        wPuts( id, doc[z] )
        -- move down a line
        y += fontY
        z += 1
    end while   
   if id=Printer then 
     if not endPage() then    -- end the page
        printErr = True        -- flag printer error
     end if
   end if
    return doc[z .. length(doc)]    -- return the unprinted portion
end function

procedure printDoc( sequence doc, sequence jobName )--[BB]--
object result
    -- empty?
    if length( doc ) = 0 then
        return        -- do nothing
    end if
   result = getPageSetup()
   if not sequence(result) then
    return
   end if
    if not startDoc( jobName ) then    -- start the document
        printErr = True      -- error
    end if
    while length( doc ) != 0    -- until end of document or error    
    and   not printErr do
        -- send document to printer; returns unprinted amount
        doc = printPage( Printer ,doc )--this will always be Printer
    end while
    if not endDoc() then    -- end the document
        printErr = True
    end if
end procedure  

   -- formorly menuItem
global procedure lprint_doc(integer id,sequence font,integer fontsize,integer fontstyle,sequence doc)
    integer  ignore    -- print document on printer --[AA]--
--notelog(sprintf("lprint_doc()--[AA]-- entered doc len=%d",length(doc)))
    printErr = False    -- clear the error flag
      setFont(id,font,fontsize,fontstyle)
    printDoc( doc, App )    -- print the document--[BB]==
    releasePrinter()    -- release the printer
    if printErr then    -- was there an error?
        ignore = message_box(   "Print File Error",         -- display an error message
                      "Error Printing File",
         MB_ICONHAND+MB_TASKMODAL )
    end if       
end procedure  

procedure set_paper_height()
  sequence extent
  integer h
  myMax(Window1)
  extent=getCtlSize(Window1)
  h=extent[2]-50
  --  setText(PAPER_HEIGHT,h)
 setRect(PAPER,300,1,20,h,0)--Resizes PAPER
end procedure

global function get_info(integer id,integer fontsize)
  sequence FontSize,Size
  integer CharsPerLine,LinesPerPage
  setFont(id, getText(FONT), fontsize, getNumber(FONT_STYLE))
  FontSize=getFontSize( id)
  Size= getCtlSize(id)
  CharsPerLine = floor(Size[1]/FontSize[1])
  LinesPerPage = floor(Size[2]/FontSize[2])
   if id = PAPER then
     setText(PAP_FONT_SIZE,fontsize)
     setText(PAPER_WIDTH,Size[1])
     setText(PAPER_HEIGHT,Size[2])
     setText(PAP_CHRW,FontSize[1])
     setText(PAP_CHRH,FontSize[2])
     setText(PAP_CHR_PER,CharsPerLine)   
     setText(PAP_LINES_PER,LinesPerPage)
   else
     setText(FONT_SIZE,fontsize)
     setText(PRINTER_WIDTH,Size[1])
     setText(PRINTER_HEIGHT,Size[2])
     setText(PRT_CHRW,FontSize[1])
     setText(PRT_CHRH,FontSize[2])
     setText(PRT_CHR_PER,CharsPerLine)   
     setText(PRT_LINES_PER,LinesPerPage)
   end if
  return Size & LinesPerPage
end function

global procedure re_cal()--find the lowest paper font
     sequence stuff,font
     integer paper_lines_per_page,paper_font_size,fontsize,fontstyle,printer_lines_per_page
       font=getText(FONT)
       fontsize=getNumber(FONT_SIZE)
       fontstyle=getNumber(FONT_STYLE)
      --   stuff=get_printer_info(font,fontsize,fontstyle)--PRINTER
         stuff=get_info(Printer,fontsize)
          printer_lines_per_page = stuff[3]
       --   stuff=get_paper_info(font,fontsize,fontstyle)--reread the paper just to be sure
          stuff=get_info(PAPER,fontsize)--reread the paper just to be sure
          paper_lines_per_page=stuff[3]
          paper_font_size=fontsize
         while paper_lines_per_page  <  printer_lines_per_page do
             paper_font_size=paper_font_size-1
           --   stuff=get_paper_info(font,paper_font_size,fontstyle)
              stuff=get_info(PAPER,paper_font_size)
             paper_lines_per_page=stuff[3]
         end while
      setText(PAP_FONT_SIZE,paper_font_size)
      myclearWindow(PAPER,BrightWhite)
  --    stuff= printPage(PAPER,pdata)--this has to be placed after whereever it was sent from
end procedure

global procedure set_edit_texts(sequence font,integer fontsize,integer fontstyle)
    setText(FONT,font)
    setText(FONT_SIZE,fontsize)
    setText(FONT_STYLE,fontstyle)
end procedure

global procedure draw_paper()
     sequence stuff,font
     integer fontsize,fontstyle
     atom printer_ratio,paper_width
       font=getText(FONT)
       fontsize=getNumber(FONT_SIZE)
       fontstyle=getNumber(FONT_STYLE)
       set_paper_height() 
    --   stuff=get_printer_info(font,fontsize,fontstyle)--PRINTER--
       stuff=get_info(Printer,fontsize)--PRINTER--
       printer_ratio=stuff[1]/stuff[2]
      --printer_lines_per_page = stuff[3]
   --   stuff=get_paper_info(font,fontsize,fontstyle)--get PAPER--
       stuff=get_info(PAPER,fontsize)
     paper_width=stuff[2]*printer_ratio--figure the paper size
     setRect(PAPER,300,40,paper_width,stuff[2],0)--the FINAL paper set
end procedure

-- the main entrance to the program
global procedure lprint4(sequence font,integer fontsize,integer fontstyle,sequence data)
    sequence stuff
    integer paper_lines_per_page,paper_font_size,printer_lines_per_page
    object junk
       set_edit_texts(font,fontsize,fontstyle)
     pdata=data
--?length(data)
?9/0
--may not be used
  junk=getPrinter()---
      draw_paper()
  printer_lines_per_page=getNumber(PRT_LINES_PER)
 -- stuff=get_paper_info(font,fontsize,fontstyle)--reread the paper
  stuff=get_info(PAPER,fontsize)
       paper_lines_per_page=stuff[3]
       paper_font_size=fontsize
        while paper_lines_per_page  <  printer_lines_per_page do
            paper_font_size=paper_font_size-1
        --      stuff=get_paper_info(font,paper_font_size,fontstyle)
              stuff=get_info(PAPER,paper_font_size)
             paper_lines_per_page=stuff[3]
        end while
     openWindow(PAPER,Normal)
       stuff= printPage(PAPER,pdata)
       setText(PAP_FONT_SIZE,paper_font_size)
       openWindow(PREVIEW,Normal)
end procedure

procedure onClick_PRNT_BTN(integer self,integer event,sequence parms)
         sequence font
         integer fontsize,fontstyle
         --  releasePrinter() can't do it here
notelog(sprintf("in printer2.e onClick_PRNT_BTN() entered pdata len=%d col_flag=%d",{length(pdata),col_flag}))  
          if col_flag=0 then
             font=getText(FONT)
             fontsize=getNumber(FONT_SIZE)
             fontstyle=getNumber(FONT_STYLE)
notelog(sprintf("Entering lprint_doc() from button pdata len=%d",length(pdata)))
             lprint_doc(Printer,font,fontsize,fontstyle,pdata)--[AA]--
          else
              conclude_col_print()  
              releasePrinter()
          end if
end procedure        
setHandler(PRINT_BTN,w32HClick,routine_id("onClick_PRNT_BTN"))

